package service

import (
	"iot_manager_service/app/device/dao"
	"iot_manager_service/app/system/service"
	"iot_manager_service/util/common"
	"iot_manager_service/util/logger"
	"strconv"
	"strings"
	"time"
)

var ManholeCoverService = new(manholeCoverService)

type manholeCoverService struct{}

func (s *manholeCoverService) Get(id int) (*dao.ManholeCover, *common.Errors) {
	// 创建查询实例
	device := &dao.ManholeCover{
		ID: id,
	}
	err := device.GetDevice()
	if err != nil {
		return nil, common.FailResponse(err.Error(), nil)
	}
	return device, nil

}

func (s *manholeCoverService) CreateOrUpdate(userId int64, tenantId string, req dao.ManholeCover) *common.Errors {
	// 创建查询实例
	device := req
	device.TenantId = tenantId
	device.UpdateUser = userId
	device.UpdateTime = time.Now()
	if req.ID == 0 {
		device.CreateTime = time.Now()
		device.CreateUser = userId
		if device.IsExistedBySN() {
			logger.Logger.Errorf("Create GetDeviceID err \n")
			return common.ParamsInvalidResponse("编码不能重复，请重新填写！", nil)
		}
		if err := device.Create(); err != nil {
			logger.Logger.Errorf("Create err = %s \n", err.Error())
			return common.FailResponse(err.Error(), nil)
		}
		service.OperationHisService.Save(userId, tenantId, common.OperationCreate, common.ModuleTypeDevice,
			common.DeviceTypeManholeCover, common.GetDeviceObject(device.ID, device.ManholeName), common.OperationSuccess)
		return common.SuccessResponse(common.Succeeded, nil)
	}
	if device.IsExistedByNameAndCode() {
		return common.ParamsInvalidResponse("编码不能重复，请重新填写！", nil)
	}

	if err := device.Update(); err != nil {
		logger.Logger.Errorf("Update err = %s \n", err.Error())
		return common.FailResponse(err.Error(), nil)
	}

	service.OperationHisService.Save(userId, tenantId, common.OperationUpdate, common.ModuleTypeDevice,
		common.DeviceTypeManholeCover, common.GetDeviceObject(device.ID, device.ManholeName), common.OperationSuccess)
	return common.SuccessResponse(common.Succeeded, nil)
}

func (s *manholeCoverService) List(searchValue string, current, size int) ([]dao.ManholeCover, int64, *common.Errors) {
	device := dao.ManholeCover{}
	if searchValue != "" {
		device.ManholeSn = searchValue
		device.ManholeName = searchValue
	}

	offset := (current - 1) * size
	limit := size
	devices, total, err := device.GetDevices(offset, limit)
	if err != nil {
		return nil, 0, common.FailResponse(err.Error(), nil)
	}
	return devices, total, nil
}

func (s *manholeCoverService) Remove(userId int64, tenantId string, id int) *common.Errors {
	// 创建查询实例
	device := &dao.ManholeCover{
		ID:         id,
		IsDeleted:  1,
		UpdateUser: userId,
		UpdateTime: time.Now(),
	}
	err := device.Delete()
	if err != nil {
		return common.FailResponse(err.Error(), nil)
	}
	service.OperationHisService.Save(userId, tenantId, common.OperationRemove, common.ModuleTypeDevice,
		common.DeviceTypeManholeCover, common.GetDeviceObject(device.ID, device.ManholeName), common.OperationSuccess)
	return nil
}

func (s *manholeCoverService) GetList(tenantId string) ([]*dao.ManholeCover, *common.Errors) {
	device := &dao.ManholeCover{
		TenantId:  tenantId,
		IsDeleted: 0,
	}
	devices, err := device.GetAllDevices()
	if err != nil {
		return nil, common.FailResponse(err.Error(), nil)
	}

	return devices, nil
}

func (s *manholeCoverService) Setting(tenantId string, id int, threshold string) error {
	split := strings.Split(threshold, ",")
	//fmt.Printf("split = %v \n", split)
	leanAngle, _ := strconv.Atoi(split[0])
	batteryAlarm, _ := strconv.ParseFloat(split[1], 64)
	minTemp, _ := strconv.ParseFloat(split[2], 64)
	maxTemp, _ := strconv.ParseFloat(split[3], 64)
	device := &dao.ManholeCover{
		TenantId:     tenantId,
		ID:           id,
		LeanAngle:    leanAngle,
		BatteryAlarm: batteryAlarm,
		MinTemp:      minTemp,
		MaxTemp:      maxTemp,
	}
	return device.Update()
}
